petsc-3.7.1 2016-05-15
Report Typos and Errors

# PCILU

Incomplete factorization preconditioners.

### Options Database Keys

| -pc_factor_levels <k> | - number of levels of fill for ILU(k) Many br
| -pc_factor_in_place | - only for ILU(0) with natural ordering, reuses the space of the matrix for Many brits factorization (overwrites original matrix) Many br
| -pc_factor_diagonal_fill | - fill in a zero diagonal even if levels of fill indicate it wouldn't be fill Many br
| -pc_factor_reuse_ordering | - reuse ordering of factorized matrix from previous factorization Many br
| -pc_factor_fill <nfill> | - expected amount of fill in factored matrix compared to original matrix, nfill > 1 Many br
| -pc_factor_nonzeros_along_diagonal | - reorder the matrix before factorization to remove zeros from the diagonal, Many brthis decreases the chance of getting a zero pivot Many br
| -pc_factor_mat_ordering_type <natural,nd,1wd,rcm,qmd> | - set the row/column ordering of the factored matrix Many br
| -pc_factor_pivot_in_blocks | - for block ILU(k) factorization, i.e. with BAIJ matrices with block size larger Many brthan 1 the diagonal blocks are factored with partial pivoting (this increases the Many brstability of the ILU factorization Many br

Many br

Notes: Only implemented for some matrix formats. (for parallel see PCHYPRE for hypre's ILU) Many br

For BAIJ matrices this implements a point block ILU Many br

The "symmetric" application of this preconditioner is not actually symmetric since L is not transpose(U) Many breven when the matrix is not symmetric since the U stores the diagonals of the factorization. Many br

If you are using MATSEQAIJCUSPARSE matrices (or MATMPIAIJCUSPARESE matrices with block Jacobi), factorization Many bris never done on the GPU). Many br

### References

| 1. | - T. Dupont, R. Kendall, and H. Rachford. An approximate factorization procedure for solving Many brself adjoint elliptic difference equations. SIAM J. Numer. Anal., 5, 1968. Many br
| 2. | - T.A. Oliphant. An implicit numerical method for solving two dimensional timedependent diffusion problems. Quart. Appl. Math., 19, 1961. Many br
| 3. | - TONY F. CHAN AND HENK A. VAN DER VORST, APPROXIMATE AND INCOMPLETE FACTORIZATIONS, Many brChapter in Parallel Numerical Many brAlgorithms, edited by D. Keyes, A. Semah, V. Venkatakrishnan, ICASE/LaRC Interdisciplinary Series in Many brScience and Engineering, Kluwer. Many br

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC, PCSOR, MatOrderingType,
PCFactorSetZeroPivot(), PCFactorSetShiftSetType(), PCFactorSetAmount(), Many brPCFactorSetDropTolerance(),PCFactorSetFill(), PCFactorSetMatOrderingType(), PCFactorSetReuseOrdering(), Many brPCFactorSetLevels(), PCFactorSetUseInPlace(), PCFactorSetAllowDiagonalFill(), PCFactorSetPivotInBlocks(), Many brPCFactorGetAllowDiagonalFill(), PCFactorGetUseInPlace() Many br

Level:beginner
Location:src/ksp/pc/impls/factor/ilu/ilu.c
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/pc/examples/tutorials/ex1.c.html
src/ksp/ksp/examples/tutorials/ex7.c.html
src/ksp/ksp/examples/tutorials/ex8.c.html
src/ksp/ksp/examples/tutorials/ex52.c.html
src/ksp/ksp/examples/tutorials/ex62.c.html